/*
 * Client.java
 */

package ejb30.inherit.entity;

import javax.persistence.*;
import java.util.*;
import ejb30.inherit.common.*;

@MappedSuperclass
public class Client extends BaseClient
   implements java.io.Serializable {

    private String clientId;
    private String clientSSN;
    private BaseInfo baseInfo;
    Collection<Account> accounts = new Vector<Account>();
    Collection<PhoneAgent> pAgents;

    public Client() { 
       super(); 
    }

    @Id
    @Column(length=55)
    public String getClientId () {
	return this.clientId;
    }
    public void setClientId (String v)
    {
	this.clientId = v;
    }

    @Column(length=55)
    public String getClientSSN ()
    {
	return this.clientSSN;
    }
    public void setClientSSN (String v)
    {
	this.clientSSN = v;
    }

    @OneToOne(cascade=CascadeType.PERSIST)
    @JoinColumn(name="FK_INFO")
    public BaseInfo getBaseInfo() {
	return baseInfo;
    }

    public void setBaseInfo(BaseInfo v) {
	this.baseInfo = v;
    }

    @OneToMany (fetch = FetchType.EAGER)
    @JoinTable(name="CLIENT_ACCT",
        joinColumns=@JoinColumn(name="C_ID", referencedColumnName="CLIENTID"),
        inverseJoinColumns=@JoinColumn(name="A_ID", referencedColumnName="ACCTNUM")
        )

    public Collection<Account> getAccounts() {
	return this.accounts;
    }

    public void setAccounts(Collection<Account> v) {
	this.accounts = v;
    }

    // Business method to add an account to the client
    public void addAccount(Account account){
         accounts.add(account);
         incrementAccountCount();
    }


    @ManyToMany 
    @JoinTable(name="CLIENT_PHONEAGENT",
        joinColumns=@JoinColumn(name="C_ID", referencedColumnName="CLIENTID"),
	inverseJoinColumns={
          @JoinColumn(name="PA_ID1", referencedColumnName="PK1"),
          @JoinColumn(name="PA_ID2", referencedColumnName="PK2")
        })

    public Collection<PhoneAgent> getPAgents() {
	return this.pAgents;
    }

    public void setPAgents(Collection<PhoneAgent> v) {
	this.pAgents = v;
    }


}

