ALTER TABLE CLIENT_PHONEAGENT DROP CONSTRAINT FK_CLIENT_PHONEAGENT_PA_ID2;
ALTER TABLE CLIENT_PHONEAGENT DROP CONSTRAINT FK_CLIENT_PHONEAGENT_C_ID;
ALTER TABLE DUMMYCLIENT DROP CONSTRAINT FK_DUMMYCLIENT_FK_VA1;
ALTER TABLE DUMMYCLIENT DROP CONSTRAINT FK_DUMMYCLIENT_CLIENT_INFO;
ALTER TABLE CLIENT_ACCT DROP CONSTRAINT FK_CLIENT_ACCT_A_ID;
ALTER TABLE CLIENT_ACCT DROP CONSTRAINT FK_CLIENT_ACCT_C_ID;
ALTER TABLE PHONEAGENTEXT DROP CONSTRAINT FK_PHONEAGENTEXT_PA_PK2;
ALTER TABLE C_INFO DROP CONSTRAINT FK_C_INFO_INFO_ID;

DROP TABLE CLIENT_PHONEAGENT;
DROP TABLE VIPCLIENTAGENT;
DROP TABLE BASE_INFO;
DROP TABLE DUMMYCLIENT;
DROP TABLE CLIENT_ACCT;
DROP TABLE ACCOUNT;
DROP TABLE PHONEAGENT;
DROP TABLE PHONEAGENTEXT;
DROP TABLE C_INFO;

CREATE TABLE CLIENT_PHONEAGENT (C_ID VARCHAR2(55) NOT NULL, 
       PA_ID1 VARCHAR2(55) NOT NULL, PA_ID2 VARCHAR2(55) NOT NULL, 
       PRIMARY KEY (C_ID, PA_ID1, PA_ID2));

CREATE TABLE VIPCLIENTAGENT (PK1I NUMBER(10) NOT NULL, 
       PK2S VARCHAR2(55) NOT NULL, DTYPE VARCHAR2(31) NULL, 
       LOCATIONID VARCHAR2(55) NULL, OFFICEPHONE VARCHAR2(55) NULL, 
       CELLPHONE VARCHAR2(55) NULL, AGENTNAME VARCHAR2(55) NULL, 
       EXT1 VARCHAR2(55) NULL, EXT2 VARCHAR2(55) NULL, 
       PRIMARY KEY (PK1I, PK2S));

CREATE TABLE BASE_INFO (ID VARCHAR2(55) NOT NULL, 
       INFO_TYPE VARCHAR2(31) NULL, NAME VARCHAR2(55) NULL, 
       PRIMARY KEY (ID));

CREATE TABLE DUMMYCLIENT (CLIENTID VARCHAR2(55) NOT NULL, 
       DTYPE VARCHAR2(31) NULL, CLIENTSSN VARCHAR2(55) NULL, 
       CLIENT_INFO VARCHAR2(55) NULL, 
       HASCREDITCARD NUMBER(1) default 0 NULL, 
       HASSAVEBOX NUMBER(1) default 0 NULL, FK_VA1 NUMBER(10) NULL, 
       FK_VA2 VARCHAR2(55) NULL, PRIMARY KEY (CLIENTID));

CREATE TABLE CLIENT_ACCT (C_ID VARCHAR2(55) NOT NULL, 
       A_ID VARCHAR2(55) NOT NULL, PRIMARY KEY (C_ID, A_ID));

CREATE TABLE ACCOUNT (ACCTNUM VARCHAR2(55) NOT NULL, 
       DCOL VARCHAR2(31) NULL, CREATED VARCHAR2(55) NULL, 
       STATUS NUMBER(10) NULL, BALANCE NUMBER(19,4) NULL, 
       NAME VARCHAR2(55) NULL, DESCRIPTION VARCHAR2(55) NULL, 
       BANK_NAME VARCHAR2(50) NULL, 
       ISOVERDRAFTALLOWED NUMBER(1) default 0 NULL, 
       TRADEFEES NUMBER(19,4) NULL, BANKNAME VARCHAR2(55) NULL, 
       SAVINGSRATE NUMBER(19,4) NULL, 
       MAXLOANALLOWED NUMBER(19,4) NULL, CREDITCARDNUMBER VARCHAR2(55) NULL, 
       ISSUINGBANK VARCHAR2(55) NULL, EXPIRESON VARCHAR2(55) NULL, 
       PRIMARY KEY (ACCTNUM));

CREATE TABLE PHONEAGENT (DTYPE VARCHAR2(31) NULL, 
       AGENTNAME VARCHAR2(55) NULL, LOCATIONID VARCHAR2(55) NULL, 
       LOCALPHONE VARCHAR2(55) NULL, TOLLPHONE VARCHAR2(55) NULL, 
       PK2 VARCHAR2(55) NOT NULL, PK1 VARCHAR2(55) NOT NULL, 
       PRIMARY KEY (PK2, PK1));

CREATE TABLE PHONEAGENTEXT (PA_PK1 VARCHAR2(55) NOT NULL, 
       PA_PK2 VARCHAR2(55) NOT NULL, EXT1 VARCHAR2(55) NULL, 
       EXT2 VARCHAR2(55) NULL, PRIMARY KEY (PA_PK1, PA_PK2));

CREATE TABLE C_INFO (INFO_ID VARCHAR2(55) NOT NULL, 
       PROP2 VARCHAR2(55) NULL, PRIMARY KEY (INFO_ID));

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT FK_CLIENT_PHONEAGENT_PA_ID2 
      FOREIGN KEY (PA_ID2, PA_ID1) REFERENCES PHONEAGENT (PK2, PK1);

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT FK_CLIENT_PHONEAGENT_C_ID 
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT FK_DUMMYCLIENT_FK_VA1 
      FOREIGN KEY (FK_VA1, FK_VA2) REFERENCES VIPCLIENTAGENT (PK1I, PK2S);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT FK_DUMMYCLIENT_CLIENT_INFO 
      FOREIGN KEY (CLIENT_INFO) REFERENCES BASE_INFO (ID);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT FK_CLIENT_ACCT_A_ID 
      FOREIGN KEY (A_ID) REFERENCES ACCOUNT (ACCTNUM);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT FK_CLIENT_ACCT_C_ID 
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE PHONEAGENTEXT ADD CONSTRAINT FK_PHONEAGENTEXT_PA_PK2 
      FOREIGN KEY (PA_PK2, PA_PK1) REFERENCES PHONEAGENT (PK2, PK1);

ALTER TABLE C_INFO ADD CONSTRAINT FK_C_INFO_INFO_ID 
      FOREIGN KEY (INFO_ID) REFERENCES BASE_INFO (ID);

